dist: trusty
sudo: true
  #
language: c
  #
dist: trusty
sudo: required
group: deprecated-2017Q2
notifications:
  email: false
  #
before_install:
  #
  # Fetch the tag information for the current branch
  - git fetch origin --tags
  #
  # Publish the buildroot script folder
  - chmod +x ${TRAVIS_BUILD_DIR}/buildroot/bin/*
  - export PATH=${TRAVIS_BUILD_DIR}/buildroot/bin/:${PATH}
  #
  # Start fb X server
  - "/sbin/start-stop-daemon --start --quiet --pidfile /tmp/custom_xvfb_1.pid --make-pidfile --background --exec /usr/bin/Xvfb -- :1 -ac -screen 0 1280x1024x16"
  - sleep 3
  - export DISPLAY=:1.0
  #
  # Teensy compiling
  - lsb_release -a
  - sudo apt-get -qq update
  - sudo apt-get install -y binutils-arm-none-eabi gcc-arm-none-eabi lib32ncurses5 lib32z1
  #
install:
  #
  # Install arduino 1.8.0
  - wget http://downloads-02.arduino.cc/arduino-1.8.0-linux64.tar.xz
  - tar xf arduino-1.8.0-linux64.tar.xz
  - sudo mv arduino-1.8.0 /usr/local/share/arduino
  - ln -s /usr/local/share/arduino/arduino ${TRAVIS_BUILD_DIR}/buildroot/bin/arduino
  #
  # Install: LiquidCrystal_I2C library
  - git clone https://github.com/kiyoshigawa/LiquidCrystal_I2C.git
  - mv LiquidCrystal_I2C/LiquidCrystal_I2C /usr/local/share/arduino/libraries/LiquidCrystal_I2C
  #
  # Install: LiquidTWI2 library
  - git clone https://github.com/lincomatic/LiquidTWI2.git
  - sudo mv LiquidTWI2 /usr/local/share/arduino/libraries/LiquidTWI2
  #
  # Install: Monochrome Graphics Library for LCDs and OLEDs
  - git clone https://github.com/olikraus/U8glib_Arduino.git
  - sudo mv U8glib_Arduino /usr/local/share/arduino/libraries/U8glib
  #
  # Install: L6470 Stepper Motor Driver library
  # - git clone https://github.com/ameyer/Arduino-L6470.git
  # - sudo mv Arduino-L6470/L6470 /usr/local/share/arduino/libraries/L6470
  #
  # Install: TMC26X Stepper Motor Controller library
  # - git clone https://github.com/trinamic/TMC26XStepper.git
  # - sudo mv TMC26XStepper /usr/local/share/arduino/libraries/TMC26XStepper
  #
  # Install: TMC2130 Stepper Motor Controller library
  - git clone https://github.com/teemuatlut/TMC2130Stepper.git
  - sudo mv TMC2130Stepper /usr/local/share/arduino/libraries/TMC2130Stepper
  #
  # Install: Adafruit Neopixel library
  - git clone https://github.com/adafruit/Adafruit_NeoPixel.git
  - sudo mv Adafruit_NeoPixel /usr/local/share/arduino/libraries/Adafruit_NeoPixel
  #
  # Install Teensy stuff

  - wget https://developer.arm.com/-/media/Files/downloads/gnu-rm/5_4-2016q2/gccarmnoneeabi542016q220160622linuxtar.bz2
  - tar xf gccarmnoneeabi542016q220160622linuxtar.bz2
  - sudo mkdir -p /usr/local/share/arduino/hardware/tools/arm
  - sudo mv gcc-arm-none-eabi-5_4-2016q2/* /usr/local/share/arduino/hardware/tools/arm/

  - wget https://github.com/ARM-software/CMSIS_5/raw/develop/CMSIS/Lib/ARM/arm_cortexM4lf_math.lib
  - sudo mv arm_cortexM4lf_math.lib /usr/local/share/arduino/hardware/tools/arm/arm-none-eabi/lib/libarm_cortexM4lf_math.a

  - git clone https://github.com/teemuatlut/teensyfiles_for_marlin.git
  - sudo mkdir -p /usr/local/share/arduino/hardware/teensy/avr
  - sudo cp teensyfiles_for_marlin/*.txt /usr/local/share/arduino/hardware/teensy/avr/

  - git clone https://github.com/PaulStoffregen/cores.git
  - sudo mv cores /usr/local/share/arduino/hardware/teensy/avr

  # Teensy libraries

  - git clone https://github.com/PaulStoffregen/Wire.git
  - git clone https://github.com/PaulStoffregen/SPI.git
  - git clone https://github.com/PaulStoffregen/Servo.git
  - sudo mkdir -p /usr/local/share/arduino/hardware/teensy/avr/libraries/
  - sudo mv Wire /usr/local/share/arduino/hardware/teensy/avr/libraries/
  - sudo mv SPI /usr/local/share/arduino/hardware/teensy/avr/libraries/
  - sudo mv Servo /usr/local/share/arduino/hardware/teensy/avr/libraries/

  - mkdir -p /usr/local/share/arduino/hardware/tools/arm
  - sudo ln -s /usr/bin /usr/local/share/arduino/hardware/tools/arm/bin
  - sudo ln -s /usr/lib /usr/local/share/arduino/hardware/tools/arm/lib
before_script:
  #
  # Change current working directory to the build dir
  - cd ${TRAVIS_BUILD_DIR}
  #
  # Generate custom version include
  - generate_version_header_for_marlin ${TRAVIS_BUILD_DIR}/Marlin
  - cat ${TRAVIS_BUILD_DIR}/Marlin/_Version.h
  #
script:
  #
  # Backup Configuration.h, Configuration_adv.h, and pins_RAMPS.h
  #
  - cp Marlin/Configuration.h Marlin/Configuration.h.backup
  - cp Marlin/Configuration_adv.h Marlin/Configuration_adv.h.backup
  - cp Marlin/pins_RAMPS.h Marlin/pins_RAMPS.h.backup
  #
  # Build with the default configurations
  #
  - build_marlin
  #
  # Test 2 extruders (one MAX6675) and heated bed on basic RAMPS 1.4
  # Test a "Fix Mounted" Probe with Safe Homing, some arc options,
  # linear bed leveling, M48, leveling debug, and firmware retraction.
  #
  - opt_set MOTHERBOARD BOARD_RAMPS_14_EEB
  - opt_set EXTRUDERS 2
  - opt_set TEMP_SENSOR_0 -2
  - opt_set TEMP_SENSOR_1 1
  - opt_set TEMP_SENSOR_BED 1
  - opt_enable PIDTEMPBED FIX_MOUNTED_PROBE Z_SAFE_HOMING ARC_P_CIRCLES CNC_WORKSPACE_PLANES
  - opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER SDSUPPORT EEPROM_SETTINGS
  - opt_enable BLINKM PCA9632 RGB_LED NEOPIXEL_RGBW_LED
  - opt_enable AUTO_BED_LEVELING_LINEAR Z_MIN_PROBE_REPEATABILITY_TEST DEBUG_LEVELING_FEATURE
  - opt_enable_adv FWRETRACT MAX7219_DEBUG
  - opt_set ABL_GRID_POINTS_X 16
  - opt_set ABL_GRID_POINTS_Y 16
  - opt_set_adv FANMUX0_PIN 53
  - build_marlin
  #
  # Test a simple build of AUTO_BED_LEVELING_UBL
  #
  - restore_configs
  - opt_enable AUTO_BED_LEVELING_UBL UBL_G26_MESH_EDITING ENABLE_LEVELING_FADE_HEIGHT FIX_MOUNTED_PROBE EEPROM_SETTINGS G3D_PANEL
  - opt_enable_adv CUSTOM_USER_MENUS I2C_POSITION_ENCODERS BABYSTEPPING
  - build_marlin
  #
  # Test a Sled Z Probe
  # ...with AUTO_BED_LEVELING_LINEAR, DEBUG_LEVELING_FEATURE, EEPROM_SETTINGS, and EEPROM_CHITCHAT
  #
  - restore_configs
  - opt_enable Z_PROBE_SLED AUTO_BED_LEVELING_LINEAR DEBUG_LEVELING_FEATURE EEPROM_SETTINGS EEPROM_CHITCHAT
  - build_marlin
  #
  # Test a Servo Probe
  # ...with AUTO_BED_LEVELING_3POINT, DEBUG_LEVELING_FEATURE, EEPROM_SETTINGS, EEPROM_CHITCHAT, EXTENDED_CAPABILITIES_REPORT, and AUTO_REPORT_TEMPERATURES
  #
  - restore_configs
  - opt_enable NUM_SERVOS Z_ENDSTOP_SERVO_NR Z_SERVO_ANGLES DEACTIVATE_SERVOS_AFTER_MOVE
  - opt_set NUM_SERVOS 1
  - opt_enable AUTO_BED_LEVELING_3POINT DEBUG_LEVELING_FEATURE EEPROM_SETTINGS EEPROM_CHITCHAT
  - opt_enable_adv EXTENDED_CAPABILITIES_REPORT AUTO_REPORT_TEMPERATURES AUTOTEMP G38_PROBE_TARGET
  - build_marlin
  #
  # Test MESH_BED_LEVELING feature, with LCD
  #
  - restore_configs
  - opt_enable MESH_BED_LEVELING MESH_G28_REST_ORIGIN LCD_BED_LEVELING ULTIMAKERCONTROLLER
  - build_marlin
  #
  # Test PROBE_MANUALLY feature, with LCD support,
  #      EEPROM_SETTINGS, EEPROM_CHITCHAT, M100_FREE_MEMORY_WATCHER,
  #      INCH_MODE_SUPPORT, TEMPERATURE_UNITS_SUPPORT
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_MINIRAMBO
  - opt_enable PROBE_MANUALLY AUTO_BED_LEVELING_BILINEAR LCD_BED_LEVELING ULTIMAKERCONTROLLER
  - opt_enable EEPROM_SETTINGS EEPROM_CHITCHAT M100_FREE_MEMORY_WATCHER M100_FREE_MEMORY_DUMPER M100_FREE_MEMORY_CORRUPTOR INCH_MODE_SUPPORT TEMPERATURE_UNITS_SUPPORT
  - build_marlin
  #
  # Test 5 extruders on AZTEEG_X3_PRO (can use any board with >=5 extruders defined)
  # Include a test for LIN_ADVANCE here also
  #
  - opt_set MOTHERBOARD BOARD_AZTEEG_X3_PRO
  - opt_set EXTRUDERS 5
  - opt_set TEMP_SENSOR_1 1
  - opt_set TEMP_SENSOR_2 5
  - opt_set TEMP_SENSOR_3 20
  - opt_set TEMP_SENSOR_4 999
  - opt_set TEMP_SENSOR_BED 1
  - opt_enable_adv LIN_ADVANCE
  - build_marlin
  #
  # Mixing Extruder with 5 steppers
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_AZTEEG_X3_PRO
  - opt_enable MIXING_EXTRUDER
  - opt_set MIXING_STEPPERS 5
  - build_marlin
  #
  # Test DUAL_X_CARRIAGE
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_RUMBA
  - opt_set EXTRUDERS 2
  - opt_set TEMP_SENSOR_1 1
  - opt_enable USE_XMAX_PLUG
  - opt_enable_adv DUAL_X_CARRIAGE
  - build_marlin
  #
  # Test SPEAKER with BOARD_BQ_ZUM_MEGA_3D and BQ_LCD_SMART_CONTROLLER
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_BQ_ZUM_MEGA_3D
  - opt_set LCD_FEEDBACK_FREQUENCY_DURATION_MS 10
  - opt_set LCD_FEEDBACK_FREQUENCY_HZ 100
  - opt_enable BQ_LCD_SMART_CONTROLLER SPEAKER
  #
  # Test SWITCHING_EXTRUDER
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_RUMBA
  - opt_set EXTRUDERS 2
  - opt_enable NUM_SERVOS
  - opt_set NUM_SERVOS 1
  - opt_set TEMP_SENSOR_1 1
  - opt_enable SWITCHING_EXTRUDER ULTIMAKERCONTROLLER
  - build_marlin
  #
  # Test MINIRAMBO for PWM_MOTOR_CURRENT
  #      ULTIMAKERCONTROLLER, FILAMENT_LCD_DISPLAY, FILAMENT_WIDTH_SENSOR,
  #      PRINTCOUNTER, NOZZLE_PARK_FEATURE, NOZZLE_CLEAN_FEATURE, PCA9632,
  #      Z_DUAL_STEPPER_DRIVERS, Z_DUAL_ENDSTOPS, BEZIER_CURVE_SUPPORT, EXPERIMENTAL_I2CBUS,
  #      FILAMENT_CHANGE_FEATURE, PARK_HEAD_ON_PAUSE, LCD_INFO_MENU,
  #
  - restore_configs
  - opt_enable ULTIMAKERCONTROLLER FILAMENT_LCD_DISPLAY FILAMENT_WIDTH_SENSOR SDSUPPORT
  - opt_enable PRINTCOUNTER NOZZLE_PARK_FEATURE NOZZLE_CLEAN_FEATURE PCA9632
  - opt_enable_adv Z_DUAL_STEPPER_DRIVERS Z_DUAL_ENDSTOPS BEZIER_CURVE_SUPPORT EXPERIMENTAL_I2CBUS
  - opt_set_adv I2C_SLAVE_ADDRESS 63
  - opt_enable_adv FILAMENT_CHANGE_FEATURE PARK_HEAD_ON_PAUSE LCD_INFO_MENU
  - pins_set RAMPS X_MAX_PIN -1
  - opt_set_adv Z2_MAX_PIN 2
  - build_marlin
  #
  # Enable COREXY
  #
  - restore_configs
  - opt_enable COREXY
  - build_marlin
  #
  # Enable COREYX (swapped)
  #
  #- restore_configs
  #- opt_enable COREYX
  #- build_marlin
  #
  #
  ######## Other Standard LCD/Panels ##############
  #
  # ULTRA_LCD
  #
  - restore_configs
  - opt_enable ULTRA_LCD
  - build_marlin
  #
  # DOGLCD
  #
  - restore_configs
  - opt_enable DOGLCD
  - build_marlin
  #
  # MAKRPANEL
  # Needs to use Melzi and Sanguino hardware
  #
  #- restore_configs
  #- opt_enable MAKRPANEL
  #- build_marlin
  #
  # REPRAP_DISCOUNT_SMART_CONTROLLER, SDSUPPORT, BABYSTEPPING, RIGIDBOARD_V2, and DAC_MOTOR_CURRENT_DEFAULT
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_RIGIDBOARD_V2
  - opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER SDSUPPORT BABYSTEPPING DAC_MOTOR_CURRENT_DEFAULT
  - build_marlin
  #
  # G3D_PANEL with SDCARD_SORT_ALPHA and STATUS_MESSAGE_SCROLLING
  #
  - restore_configs
  - opt_enable G3D_PANEL SDSUPPORT
  - opt_enable_adv SDCARD_SORT_ALPHA STATUS_MESSAGE_SCROLLING
  - opt_set_adv SDSORT_GCODE true
  - opt_set_adv SDSORT_USES_RAM true
  - opt_set_adv SDSORT_USES_STACK true
  - opt_set_adv SDSORT_CACHE_NAMES true
  - build_marlin
  #
  # REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER with SDCARD_SORT_ALPHA and STATUS_MESSAGE_SCROLLING
  #
  - restore_configs
  - opt_enable REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER SDSUPPORT
  - opt_enable_adv SDCARD_SORT_ALPHA STATUS_MESSAGE_SCROLLING
  - build_marlin
  #
  # REPRAPWORLD_KEYPAD
  #
  # Cant find configuration details to get it to compile
  #- restore_configs
  #- opt_enable ULTRA_LCD REPRAPWORLD_KEYPAD REPRAPWORLD_KEYPAD_MOVE_STEP
  #- build_marlin
  #
  # RA_CONTROL_PANEL
  #
  - restore_configs
  - opt_enable RA_CONTROL_PANEL PINS_DEBUGGING
  - build_marlin
  #
  ######## I2C LCD/PANELS ##############
  #
  # !!!ATTENTION!!!
  # Most I2C configurations are failing at the moment because they require
  # a different Liquid Crystal library "LiquidTWI2".
  #
  # LCD_I2C_SAINSMART_YWROBOT
  #
  #- restore_configs
  #- opt_enable LCD_I2C_SAINSMART_YWROBOT
  #- build_marlin
  #
  # LCD_I2C_PANELOLU2
  #
  #- restore_configs
  #- opt_enable LCD_I2C_PANELOLU2
  #- build_marlin
  #
  # LCD_I2C_VIKI
  #
  #- restore_configs
  #- opt_enable LCD_I2C_VIKI
  #- build_marlin
  #
  # LCM1602
  #
  - restore_configs
  - opt_enable LCM1602
  - build_marlin
  #
  #
  ######## Example Configurations ##############
  #
  # BQ Hephestos 2
  #- restore_configs
  #- use_example_configs Hephestos_2
  #- build_marlin
  #
  # Delta Config (generic) + ABL bilinear + PROBE_MANUALLY
  - use_example_configs delta/generic
  - opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER DELTA_CALIBRATION_MENU AUTO_BED_LEVELING_BILINEAR PROBE_MANUALLY
  - build_marlin
  #
  # Delta Config (generic) + UBL + ALLEN_KEY + OLED_PANEL_TINYBOY2 + EEPROM_SETTINGS
  #
  - use_example_configs delta/generic
  - opt_disable DISABLE_MIN_ENDSTOPS
  - opt_enable AUTO_BED_LEVELING_UBL Z_PROBE_ALLEN_KEY EEPROM_SETTINGS EEPROM_CHITCHAT OLED_PANEL_TINYBOY2
  - build_marlin
  #
  # Delta Config (FLSUN AC because it's complex)
  #
  - use_example_configs delta/FLSUN/auto_calibrate
  - build_marlin
  #
  # Makibox Config  need to check board type for Teensy++ 2.0
  #
  #- use_example_configs makibox
  #- build_marlin
  #
  # SCARA with TMC2130
  #
  - use_example_configs SCARA
  - opt_enable AUTO_BED_LEVELING_BILINEAR FIX_MOUNTED_PROBE USE_ZMIN_PLUG EEPROM_SETTINGS EEPROM_CHITCHAT ULTIMAKERCONTROLLER
  - opt_enable_adv HAVE_TMC2130 X_IS_TMC2130 Y_IS_TMC2130 Z_IS_TMC2130
  - opt_enable_adv AUTOMATIC_CURRENT_CONTROL STEALTHCHOP HYBRID_THRESHOLD SENSORLESS_HOMING
  - build_marlin
  #
  # tvrrug Config need to check board type for sanguino atmega644p
  #
  #- use_example_configs tvrrug/Round2
  #- build_marlin
  #
  #
  ######## Board Types #############
  #
  # To be added in nightly test branch
  #
  # Backup Configuration.h, Configuration_adv.h, and pins_RAMPS.h
  #
  - restore_configs
  - opt_set MOTHERBOARD BOARD_TEENSY35_36
  - cp Marlin/Configuration.h Marlin/Configuration.h.backup
  - cp Marlin/Configuration_adv.h Marlin/Configuration_adv.h.backup
  - cp Marlin/pins_RAMPS.h Marlin/pins_RAMPS.h.backup
  #
  # Test Teensy3.5 with default config
  #
  - build_marlin_teensy35
  #
  # Test heated bed temperature sensor
  #
  - opt_set TEMP_SENSOR_BED 1
  - build_marlin_teensy35
  #
  # Test 2 extruders on basic RAMPS 1.4
  #
  - opt_set EXTRUDERS 2
  - opt_set TEMP_SENSOR_1 1
  - build_marlin_teensy35
  #
  # Test PIDTEMPBED
  #
  - restore_configs
  - opt_enable PIDTEMPBED
  - build_marlin_teensy35
  #
  # Test a "Fix Mounted" Probe along with Safe Homing
  #
  - restore_configs
  - opt_enable FIX_MOUNTED_PROBE Z_SAFE_HOMING
  - build_marlin_teensy35
  #
  # ...with AUTO_BED_LEVELING_LINEAR, Z_MIN_PROBE_REPEATABILITY_TEST, and DEBUG_LEVELING_FEATURE
  #
  - opt_enable AUTO_BED_LEVELING_LINEAR Z_MIN_PROBE_REPEATABILITY_TEST DEBUG_LEVELING_FEATURE
  - opt_set ABL_GRID_POINTS_X 16
  - opt_set ABL_GRID_POINTS_Y 16
  - build_marlin_teensy35
  #
  # Test a Sled Z Probe
  #
  - restore_configs
  - opt_enable Z_PROBE_SLED
  - build_marlin_teensy35
  #
  # ...with AUTO_BED_LEVELING_LINEAR, DEBUG_LEVELING_FEATURE, EEPROM_SETTINGS, and EEPROM_CHITCHAT
  #
  - opt_enable AUTO_BED_LEVELING_LINEAR DEBUG_LEVELING_FEATURE EEPROM_SETTINGS EEPROM_CHITCHAT
  - build_marlin_teensy35
  #
  # Test a Servo Probe
  #
  - restore_configs
  - opt_enable NUM_SERVOS Z_ENDSTOP_SERVO_NR Z_SERVO_ANGLES DEACTIVATE_SERVOS_AFTER_MOVE
  - build_marlin_teensy35
  #
  # ...with AUTO_BED_LEVELING_3POINT, DEBUG_LEVELING_FEATURE, EEPROM_SETTINGS, EEPROM_CHITCHAT, EXTENDED_CAPABILITIES_REPORT, and AUTO_REPORT_TEMPERATURES
  #
  - opt_enable AUTO_BED_LEVELING_3POINT DEBUG_LEVELING_FEATURE EEPROM_SETTINGS EEPROM_CHITCHAT
  - opt_enable_adv EXTENDED_CAPABILITIES_REPORT AUTO_REPORT_TEMPERATURES
  - build_marlin_teensy35
  #
  # Test MESH_BED_LEVELING feature, with LCD
  #
  - restore_configs
  - opt_enable MESH_BED_LEVELING MESH_G28_REST_ORIGIN MANUAL_BED_LEVELING ULTIMAKERCONTROLLER
  - build_marlin_teensy35
  #
  # Test EEPROM_SETTINGS, EEPROM_CHITCHAT, M100_FREE_MEMORY_WATCHER,
  #   INCH_MODE_SUPPORT, TEMPERATURE_UNITS_SUPPORT
  #
  - restore_configs
  # - opt_enable M100_FREE_MEMORY_WATCHER // Compiler error!
  - opt_enable EEPROM_SETTINGS EEPROM_CHITCHAT INCH_MODE_SUPPORT TEMPERATURE_UNITS_SUPPORT
  - build_marlin_teensy35
  #
  # Mixing Extruder
  #
  - restore_configs
  - opt_enable MIXING_EXTRUDER
  - opt_set MIXING_STEPPERS 2
  - build_marlin_teensy35
  #
  # Test DUAL_X_CARRIAGE
  #
  #- restore_configs
  #- opt_set EXTRUDERS 2
  #- opt_set TEMP_SENSOR_1 1
  #- opt_enable USE_XMAX_PLUG
  #- opt_enable_adv DUAL_X_CARRIAGE
  #- build_marlin_teensy35
  #
  # Test SWITCHING_EXTRUDER
  #
  - restore_configs
  - opt_set EXTRUDERS 2
  - opt_enable NUM_SERVOS
  - opt_set NUM_SERVOS 1
  - opt_set TEMP_SENSOR_1 1
  - opt_enable SWITCHING_EXTRUDER ULTIMAKERCONTROLLER
  - build_marlin_teensy35
  #
  # Test FILAMENT_CHANGE_FEATURE and LCD_INFO_MENU
  #
  - restore_configs
  - opt_enable ULTIMAKERCONTROLLER
  - opt_enable_adv FILAMENT_CHANGE_FEATURE LCD_INFO_MENU
  - build_marlin_teensy35
  #
  # Enable filament sensor
  #
  - restore_configs
  - opt_enable FILAMENT_WIDTH_SENSOR
  - build_marlin_teensy35
  #
  # Enable filament sensor with LCD display
  #
  - opt_enable ULTIMAKERCONTROLLER FILAMENT_LCD_DISPLAY
  - build_marlin_teensy35
  #
  # Enable BEZIER_CURVE_SUPPORT, EXPERIMENTAL_I2CBUS, and I2C_SLAVE_ADDRESS
  #
  - restore_configs
  - opt_enable_adv BEZIER_CURVE_SUPPORT EXPERIMENTAL_I2CBUS
  - opt_set_adv I2C_SLAVE_ADDRESS 63
  - build_marlin_teensy35
  #
  # Enable COREXY
  #
  - restore_configs
  - opt_enable COREXY
  - build_marlin_teensy35
  #
  # Enable COREXZ
  #
  - restore_configs
  - opt_enable COREXZ
  - build_marlin_teensy35
  #
  # Enable Z_DUAL_STEPPER_DRIVERS, Z_DUAL_ENDSTOPS
  #
  - restore_configs
  - opt_enable_adv Z_DUAL_STEPPER_DRIVERS Z_DUAL_ENDSTOPS
  - pins_set RAMPS X_MAX_PIN -1
  - opt_set_adv Z2_MAX_PIN 2
  - build_marlin_teensy35
  #
  # Test PRINTCOUNTER
  #
  - restore_configs
  - opt_enable PRINTCOUNTER
  - build_marlin_teensy35
  #
  # Test NOZZLE_PARK_FEATURE
  #
  - restore_configs
  - opt_enable NOZZLE_PARK_FEATURE
  - build_marlin_teensy35
  #
  # Test NOZZLE_CLEAN_FEATURE
  #
  - restore_configs
  - opt_enable NOZZLE_CLEAN_FEATURE
  - build_marlin_teensy35
  #
  #
  ######## STANDARD LCD/PANELS ##############
  #
  # ULTRA_LCD
  #
  - restore_configs
  - opt_enable ULTRA_LCD
  - build_marlin_teensy35
  #
  # DOGLCD
  #
  - restore_configs
  - opt_enable DOGLCD
  - build_marlin_teensy35
  #
  # ULTIMAKERCONTROLLER
  #
  - restore_configs
  - opt_enable ULTIMAKERCONTROLLER
  - build_marlin_teensy35
  #
  # MAKRPANEL
  # Needs to use Melzi and Sanguino hardware
  #
  #- restore_configs
  #- opt_enable MAKRPANEL
  #- build_marlin
  #
  # REPRAP_DISCOUNT_SMART_CONTROLLER, SDSUPPORT, and BABYSTEPPING
  #
  - restore_configs
  - opt_enable REPRAP_DISCOUNT_SMART_CONTROLLER SDSUPPORT BABYSTEPPING
  - build_marlin_teensy35
  #
  # G3D_PANEL
  #
  - restore_configs
  - opt_enable G3D_PANEL SDSUPPORT
  - build_marlin_teensy35
  #
  # REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER
  #
  - restore_configs
  - opt_enable REPRAP_DISCOUNT_FULL_GRAPHIC_SMART_CONTROLLER SDSUPPORT
  - build_marlin_teensy35
  #
  # REPRAPWORLD_KEYPAD
  #
  # Cant find configuration details to get it to compile
  #- restore_configs
  #- opt_enable ULTRA_LCD REPRAPWORLD_KEYPAD REPRAPWORLD_KEYPAD_MOVE_STEP
  #- build_marlin
  #
  # RA_CONTROL_PANEL
  #
  - restore_configs
  - opt_enable RA_CONTROL_PANEL
  - build_marlin_teensy35
  #
  ######## I2C LCD/PANELS ##############
  #
  # !!!ATTENTION!!!
  # Most I2C configurations are failing at the moment because they require
  # a different Liquid Crystal library "LiquidTWI2".
  #
  # LCD_I2C_SAINSMART_YWROBOT
  #
  #- restore_configs
  #- opt_enable LCD_I2C_SAINSMART_YWROBOT
  #- build_marlin
  #
  # LCD_I2C_PANELOLU2
  #
  #- restore_configs
  #- opt_enable LCD_I2C_PANELOLU2
  #- build_marlin
  #
  # LCD_I2C_VIKI
  #
  #- restore_configs
  #- opt_enable LCD_I2C_VIKI
  #- build_marlin
  #
  # LCM1602
  #
  - restore_configs
  - opt_enable LCM1602
  - build_marlin_teensy35
